#ifndef CONSOLE_H
#define CONSOLE_H

#include "eq.h"

/* eq.c needs to view these */
struct ConsoleEvent{
  char consoleadjust;     /* one of the following is being adjusted otherwise look no further */
  int track, group;

  struct Track *currenttrack;        /* pointer to track in database being adjusted */
  struct TrackGroup *currentgroup;   /* pointer to track group in database being adjusted */

  char leveladjust;
  char slideradjust;

  char panadjust;
  int pan;          /* which pan is being adjusted */

  char eqleveladjust;
  char eqfreqadjust;
  char eqwidthadjust;
  char eq;          /* which eq is being adjusted */

  struct Eq *currenteq;         /* pointer to eq values */

} consoleevent;                 /* console event flags */

extern const float maxlevel;
extern const float minlevel;
extern const float maxpan;
extern const float minpan;
extern const float maxeq;
extern const float mineq;

struct PatchEvent{
  char patchadjust;
  char recpatchadjust;
  char playpatchadjust;
  char on;
} patchevent;              /* patch event flags */

/* eq.c needs to view these */
extern struct consolewindow_ {
  int w;
  int h;
  char *title;
  int moduleh, modulew;

  bceq eq[TOTALEQS];

  bcslider level;
  bcslider pan;
  bcbutton group;
  bcbox invert;

  bcscroll scroll;
} consolewindow;

void drawconsolecontrol(struct Track *currenttrack, int y, int track);
void drawconsolecontrols();
void consolebuttonpress(XEvent *report);
void consolemotion(XEvent *report);
void consolebuttonrelease(XEvent *report);
void consolekeypress(XEvent *report);
void patchbuttonpress(XEvent *report);
void patchmotion(XEvent *report);
void patchbuttonrelease(XEvent *report);
void consoleincreaselevel();
void consoledecreaselevel();
int editconsolegroup(struct TrackGroup *currentgroup);
void writegroups(FILE *out);
void readgroups(FILE *in, int newchannels, int track1);
void addgroup();
void deletegroup(struct TrackGroup *currentgroup);

#endif
