#ifndef DATABASE_H
#define DATABASE_H

typedef struct{
	
} bcdatabase;

/* file utilities */
void putfourswap(FOUR number, FILE *file);
void putfour(FOUR number, FILE *file);
void puttwo(TWO number, FILE *file);
void putfloat(float number, FILE *file);
float getfloat(FILE *file);
TWO gettwo(FILE *in);
FOUR getfour(FILE *in);
FOUR getfourswap(FILE *in);
void assigntext(char **location, char *filename);
void readtext(FILE *in, char **text);
void setpans(float **pan, int track);
void readpans(FILE *in, float *pan, int channels);
void writepans(float *pans, FILE *out, int channels);

/* statistical operations */
long longesttrack();
int edits(struct Track *track);
int tracks();
int recordabletracks();
int groups();
struct TrackGroup *groupof(int starty);
long labels();

/* location functions */
struct Edit *segmentof(long x, struct Track *currenttrack);
struct Track *trackof(int starty);
struct Label *labelof(long x);

/* initialization functions */
void cleardatabase();
void clearlabels();

/* optimization functions */
int optimizeedits();
int optimizelabels();

/* label functions */
void insertlabel(long x);
void deletelabel(long x);

/* debugging functions */
void dumpedits();
int dumplabels();

/* user functions */
void togglelabel(long start);
int selectlabel(XEvent *report);
void copytrack(struct Track *track1, struct Track *track2);
int addtrack();
int deletetrack();
int changechannels();
int setsamplerate();

#endif
