/*
  Broadcast 2.0 multitrack audio editing
  (c) 1997 Adam Williams

  This program is distributed with the intent that it will be useful, without
  any warranty.  The code is being updated and has many bugs which are
  constantly being elucidated so changes should not be made without notifying
  the author.
*/

/* defs.c      global definitions and variables  */

#include "defs.h"

char INITIALIZERFILE[256] = "";
char CLIPBOARDFILENAME[256] = "";
char UNDOCLIPFILENAME[256] = "";
char AUTOCLIPBOARDFILENAME[256] = "";
char UNDOAUTOCLIPFILENAME[256] = "";
char UNDOFILENAME[256] = "";
char UNDOTEMPFILE[256] = "";

TWO screenwidth, screenheight;
FOUR startx;               /* current position of view in virtual file */
FOUR starty;               /* current track at start of view */
FOUR consolestarty;             /* current track at start of console view */
FOUR groupstarty;          /* current group at start of groups */
FOUR timescale;
FOUR xscale;               /* horizontal scale of view */
FOUR yscale;               /* vertical scale of wave */
FOUR yscaletrack;
FOUR selectionstart;       /* current selection start */
FOUR selectionend;         /* current selection end */
FOUR currentposition;      /* current position for playback */
char shiftlabels;
char titles;               /* draw titles if 1 */
char highqualityrefresh;   /* high quality wave draw if 1 */
char showtrackgroups, showedits;      /* show track groups if 1, console if 0 */
char byteorder;                /* 1 if intel  0 if normal */
FOUR PLAYBUFFER, RECBUFFER;    /* variable buffer sizes for playback */

int screen;
Display *display;
Window patchwin, wavwin, rootwin, win;
Window labelwin, timewin, menuwin;
Window popupwin, popupsubwin;
Pixmap popuppixmap, popupsubpixmap;
Window playwin, consolewin;
Pixmap playpixmap, consolepixmap;
Pixmap patchpixmap, wavpixmap;
Pixmap labelpixmap, timepixmap, menupixmap;
GC gc;
int depth;

XFontStruct *menufont, *smallfont;

Colormap cmap;
XColor orange, green, red, ltgrey;
XColor grey, migrey, dkgrey, ltcyan;
XColor cyan, micyan, dkcyan, pink;
XColor black, white, yellow, purple;
XColor blue;

struct WaveWindow wavewindow = {0, 0, 0, 0};
struct PatchWindow patchwindow = {0, 0, 0, 0};
struct LabelWindow labelwindow = {0, 0, 0, 0};
struct MenuWindow menuwindow = {0, 0, 0, 0};
struct TimeWindow timewindow = {0, 0, 0, 0};

/*=================================database=============================*/
struct Track *firsttrack = 0; /* pointer to first track in database */
struct Track *lasttrack = 0;  /* pointer to last track in database */

struct Label *firstlabel = 0;
struct Label *lastlabel = 0;

struct TrackGroup *firsttrackgroup = 0;
struct TrackGroup *lasttrackgroup = 0;

TWO outchannels;           /* total output channels */
FOUR samplerate;
char changesmade;
float mainlevel = 1;

