#ifndef EFFECTS_H
#define EFFECTS_H

#include "defs.h"

extern int writechannel;            /* channel for writebuffer and nextchannel */
extern char effectfiletype;         /* filetype for effects */
extern struct CastHeader *castheader;
extern FILE *out;
extern long totallength, progress;
extern char *outbufferstart_;
extern int totaltracks, frame;
extern char filename[256];

void loadiniteffectdir(FILE *in);
void loadiniteffecttype(int value);
void saveiniteffecttype(FILE *out);
void saveiniteffectdir(FILE *out);

int initeffectfile();
void killeffectfile();
void nextchannel();
int writebuffer(char *bufferstart, long buffersize);
int closeeffectfile();

int crossfade(long selectionstart, long selectionend);

void loadnormalizelevel(FILE *in, float value);
void savenormalizelevel(FILE *out);
int normalize(long selectionstart, long selectionend);

int balance(long selectionstart, long selectionend);

void loadreverbparams(FILE *in, long value);
void savereverbparams(FILE *out);
int reverb(long selectionstart, long selectionend);
int backwards(long selectionstart, long selectionend);

#endif
