/*
  Broadcast 2.0 multitrack audio editing
  (c) 1997 Adam Williams

  This program is distributed with the intent that it will be useful, without
  any warranty.  The code is being updated and has many bugs which are
  constantly being elucidated so changes should not be made without notifying
  the author.
*/

/* eq.c      equalization interface and processing  */

#include <math.h>

#include "interfac.h"
#include "eq.h"
#include "database.h"
#include "console.h"
#include "units.h"

void draweqcontrol(Drawable wdw, Window win, struct Eq *currenteq, int y)
{
  static int i, y1;
  static char string[10];

  for(i = 0; i < TOTALEQS; i++)
  {
                            /* set y positions and values of the controls */
  	consolewindow.eq[i].levelpot.y =  y + 6;
  	consolewindow.eq[i].freqpot.y = y + 16;
  	consolewindow.eq[i].widthpot.y = y + 6;
    consolewindow.eq[i].levelpot.value = currenteq[i].level;
    consolewindow.eq[i].freqpot.value = currenteq[i].freq;
    consolewindow.eq[i].widthpot.value = currenteq[i].width;

    consolewindow.eq[i].in.y = consolewindow.eq[i].bp.y = y + consolewindow.moduleh
    	- 20;
    
    initpot(consolewin, consolepixmap, &consolewindow.eq[i].levelpot, 0);
    initpot(consolewin, consolepixmap, &consolewindow.eq[i].freqpot, 0);
    initpot(consolewin, consolepixmap, &consolewindow.eq[i].widthpot, 0);

            /* draw eq switch */
    if(currenteq[i].in == 1) DrawDnRadial(consolepixmap, &consolewindow.eq[i].in);
    else  DrawUpRadial(wdw, &consolewindow.eq[i].in);

            /* draw bp switch */
    if(currenteq[i].in == 2) DrawDnRadial(consolepixmap, &consolewindow.eq[i].bp);
    else  DrawUpRadial(wdw, &consolewindow.eq[i].bp);

		DrawEqIcon(consolepixmap, &consolewindow.eq[i].in);
		DrawBpIcon(consolepixmap, &consolewindow.eq[i].bp);		

    XSetForeground(display, gc, red.pixel);
    sprintf(string, "EQ %d", i+1);
    XDrawString(display, consolepixmap, gc, 
    	consolewindow.eq[i].x + consolewindow.eq[i].w - 25,
      y + consolewindow.moduleh - 5,
      string, strlen(string));
    XSetForeground(display, gc, black.pixel);
  }
}

void testeq(int x, int y, int track, struct Eq *currenteq){
  static bcbox box;
  static int i;

  for(i = 0; i < TOTALEQS; i++){
                            /* set y positions of the controls */
  	consolewindow.eq[i].levelpot.y = (track - consolestarty) * consolewindow.moduleh + 6;
  	consolewindow.eq[i].freqpot.y = (track - consolestarty) * consolewindow.moduleh + 16;
  	consolewindow.eq[i].widthpot.y = (track - consolestarty) * consolewindow.moduleh + 6;
    consolewindow.eq[i].in.y = consolewindow.eq[i].bp.y = 
	    (track - consolestarty) * consolewindow.moduleh + consolewindow.moduleh
    	- 20;

    if(testbox(x, y, (bcbox *)&consolewindow.eq[i].levelpot)){ /* test level */
      consoleevent.consoleadjust = 1;
      consoleevent.eqleveladjust = 1;
      consoleevent.eq = i;
      consoleevent.track = track;
      consoleevent.currenteq = currenteq;
      goto end;
    }

    if(testbox(x, y, (bcbox *)&consolewindow.eq[i].freqpot)){  /* test freq */
      consoleevent.consoleadjust = 1;
      consoleevent.eqfreqadjust = 1;
      consoleevent.eq = i;
      consoleevent.track = track;
      consoleevent.currenteq = currenteq;
      goto end;
    }

    if(testbox(x, y, (bcbox *)&consolewindow.eq[i].widthpot)){ /* test width */
      consoleevent.consoleadjust = 1;
      consoleevent.eqwidthadjust = 1;
      consoleevent.eq = i;
      consoleevent.track = track;
      consoleevent.currenteq = currenteq;
      goto end;
    }

                  /* switch eq in and out */
    if(testbox(x, y, (bcbox *)&consolewindow.eq[i].in)){
      if(currenteq[i].in != 1) currenteq[i].in = 1;
      else currenteq[i].in = 0;
      
      if(currenteq[i].in == 1){
      	DrawDnRadial(consolepixmap, &consolewindow.eq[i].in);
      	DrawUpRadial(consolepixmap, &consolewindow.eq[i].bp);
      }else
      	DrawUpRadial(consolepixmap, &consolewindow.eq[i].in);

			DrawEqIcon(consolepixmap, &consolewindow.eq[i].in);
			DrawBpIcon(consolepixmap, &consolewindow.eq[i].bp);		

      XCopyArea(display, consolepixmap, consolewin, gc,
        consolewindow.eq[i].in.x, consolewindow.eq[i].in.y,
        consolewindow.eq[i].in.w * 3 + 1, consolewindow.eq[i].in.h + 2,
        consolewindow.eq[i].in.x, consolewindow.eq[i].in.y);
      XFlush(display);
      goto end;
    }
    
                  /* switch bp in and out */
    if(testbox(x, y, (bcbox *)&consolewindow.eq[i].bp)){
      if(currenteq[i].in != 2) currenteq[i].in = 2;
      else currenteq[i].in = 0;
      
      if(currenteq[i].in == 2){
      	DrawDnRadial(consolepixmap, &consolewindow.eq[i].bp);
      	DrawUpRadial(consolepixmap, &consolewindow.eq[i].in);
      }else
      	DrawUpRadial(consolepixmap, &consolewindow.eq[i].bp);

			DrawEqIcon(consolepixmap, &consolewindow.eq[i].in);
			DrawBpIcon(consolepixmap, &consolewindow.eq[i].bp);		

      XCopyArea(display, consolepixmap, consolewin, gc,
        consolewindow.eq[i].in.x, consolewindow.eq[i].in.y,
        consolewindow.eq[i].in.w * 3 + 1, consolewindow.eq[i].in.h + 2,
        consolewindow.eq[i].in.x, consolewindow.eq[i].in.y);
      XFlush(display);
    }
  }
end:
  ;
}

void eqlevelmotion(XEvent *report){
  static struct Eq *currenteq;
  static int i;

  currenteq = consoleevent.currenteq;
  i = consoleevent.eq;

             /* levelpot coordinates were set in testeq */
  potevent(consolewin, consolepixmap, report, &consolewindow.eq[i].levelpot, 1);

  currenteq[i].level = consolewindow.eq[i].levelpot.value;
}

void eqfreqmotion(XEvent *report){
  static struct Eq *currenteq;
  static int i;

  currenteq = consoleevent.currenteq;
  i = consoleevent.eq;

             /* levelpot coordinates were set in testeq */
  potevent(consolewin, consolepixmap, report, &consolewindow.eq[i].freqpot, 1);

  currenteq[i].freq = consolewindow.eq[i].freqpot.value;
}

void eqwidthmotion(XEvent *report){
  static struct Eq *currenteq;
  static int i;

  currenteq = consoleevent.currenteq;
  i = consoleevent.eq;

             /* levelpot coordinates were set in testeq */
  potevent(consolewin, consolepixmap, report, &consolewindow.eq[i].widthpot, 1);

  currenteq[i].width = consolewindow.eq[i].widthpot.value;
}

void writeeq(FILE *out){
  struct Track *currenttrack;
  int i;

  puttwo(tracks(), out);

  for(currenttrack = firsttrack;
    currenttrack;
    currenttrack = currenttrack->nexttrack)
  {
    for(i = 0; i < TOTALEQS; i++){
      putfloat(currenttrack->eq[i].level, out);
      puttwo(currenttrack->eq[i].freq, out);
      puttwo(currenttrack->eq[i].width, out);
      fputc(currenttrack->eq[i].in, out);
    }
  }
}

void readeq(FILE *in, int track1){
  struct Track *currenttrack;
  int tracknumber, newtracks;
  int i;

  newtracks = gettwo(in);

  for(currenttrack = trackof(track1), tracknumber = 0;
    currenttrack && tracknumber < newtracks;
    currenttrack = currenttrack->nexttrack, tracknumber++)
  {
    for(i = 0; i < TOTALEQS; i++){
      currenttrack->eq[i].level = getfloat(in);
      currenttrack->eq[i].freq = gettwo(in);
      currenttrack->eq[i].width = gettwo(in);
      currenttrack->eq[i].in = fgetc(in);
    }
  }
}

void initeq(int track1, int newtracks){
  struct Track *currenttrack;
  int i;

  for(currenttrack = trackof(track1);
    currenttrack;
    currenttrack = currenttrack->nexttrack)
  {
    for(i = 0; i < TOTALEQS; i++){
      currenttrack->eq[i].level = 0;
      currenttrack->eq[i].freq = 0;
      currenttrack->eq[i].width = 2;
      currenttrack->eq[i].in = 0;
    }
  }
}

/* alters inbuffer directly */
/* scale1 is a power */
void processeq(char *inbufferstart, long inbufferlength, struct Eq *currenteq,
  double *prevout, float *scale1)
{
  register TWO *inbufferend;
  register TWO *inbuffer_;
  register double a, b, c;
  register double out, *out1, *out2;
  static float center, width, scale;
  static int i;
  static long lofreq, hifreq;        /* lower and upper frequency of band */

  inbufferend = (TWO *)inbufferstart + inbufferlength / 2;
                                       /* mix all bands into coefficients*/
  for(i = 0; i < TOTALEQS; i++){
                   /* current eq is on and level is non zero */
    if(currenteq[i].level != 0 && currenteq[i].in == 1)
    {
      out1 = &prevout[2 * i];
      out2 = &prevout[2 * i + 1];
      lofreq = currenteq[i].freq - currenteq[i].width / 2;
      hifreq = currenteq[i].freq + currenteq[i].width / 2;
      if(lofreq < 0)  lofreq = 0;
      if(hifreq > TOTALFREQS) hifreq = TOTALFREQS;
      lofreq = tofreq(lofreq);
      hifreq = tofreq(hifreq);
      center = (lofreq + hifreq) / 2;
      width = hifreq - lofreq;

      scale = topower[(int)(currenteq[i].level * 10)] - 1;

      c = exp(-2 * 3.14159265 * width / samplerate);
      b = -4 * c / (1 + c) * cos(2 * 3.14159265 * center / samplerate);
      a = sqrt(1 - b * b / (4 * c)) * (1 - c) * scale;

#ifndef FLOAT_BUG
      if(*scale1 == 1){          /*========= eq additional band ===========*/
      	inbuffer_ = (TWO *)inbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
				inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_;

          out = a * out - b * *out1 - c * *out2;

          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
      }else{             /*======== eq first band ========*/
      	inbuffer_ = (TWO *)inbufferstart;
      	
				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          out = a * out - b * *out1 - c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
        inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;

          out = a * out - b * *out1 - c * *out2;

          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        *scale1 = 1;         /* reset scale1 if scale has been done */
      }
#else
      if(*scale1 == 1){           /* eq additional band */
      	inbuffer_ = (TWO *)inbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_;
                           /* check to see if 0 to avoid slowing down */
                           /* on HP eqing 0 slowed it down sometimes */
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
				inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_;

                           /* check to see if 0 to avoid slowing down */
                           /* on HP eqing 0 slowed it down sometimes */
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;

          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
      }else{                       /* eq first band */
      	inbuffer_ = (TWO *)inbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
        inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_;

                           /* check to see if 0 to avoid slowing down */
                           /* on HP eqing 0 slowed it down sometimes */
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;

          *inbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        *scale1 = 1;         /* reset scale1 if scale has been done */
      }
#endif
    }
  }
}

/* process band pass filter */
/* set firstbp to 1 to clear output buffer */
/* copies inbuffer to outbuffer */
/* scale1 is a power */
void processbp(char *inbufferstart, long inbufferlength, char *outbufferstart, 
	struct Eq *currenteq, double *prevout, float *scale1, char *firstbp)
{
  register TWO *inbufferend, *outbufferend;
  register TWO *inbuffer_, *outbuffer_;
  register double a, b, c;
  register double out, *out1, *out2;
  static float center, width, scale;
  static int i;
  static long lofreq, hifreq;        /* lower and upper frequency of band */

  inbufferend = (TWO *)inbufferstart + inbufferlength / 2;

                                       /* mix all bands into coefficients*/
  for(i = 0; i < TOTALEQS; i++){
                   /* current eq or band pass is on or level is non zero */
    if(currenteq[i].in == 2)
    {
      out1 = &prevout[2 * i];
      out2 = &prevout[2 * i + 1];
      lofreq = currenteq[i].freq - currenteq[i].width / 2;
      hifreq = currenteq[i].freq + currenteq[i].width / 2;
      if(lofreq < 0)  lofreq = 0;
      if(hifreq > TOTALFREQS) hifreq = TOTALFREQS;
      lofreq = tofreq(lofreq);
      hifreq = tofreq(hifreq);
      center = (lofreq + hifreq) / 2;
      width = hifreq - lofreq;

      scale = topower[(int)(currenteq[i].level * 10)];

      c = exp(-2 * 3.14159265 * width / samplerate);
      b = -4 * c / (1 + c) * cos(2 * 3.14159265 * center / samplerate);
      a = sqrt(1 - b * b / (4 * c)) * (1 - c) * scale;

			if(*firstbp){ /* clear output buffer if first bp filter */
				outbufferend = (TWO *)outbufferstart + inbufferlength / 2;
				outbuffer_ = (TWO *)outbufferstart;

				outbufferend -= 4;
				while(outbuffer_ < outbufferend){
					*outbuffer_++ = 0;
					*outbuffer_++ = 0;
					*outbuffer_++ = 0;
					*outbuffer_++ = 0;
				}

				outbufferend += 4;
				while(outbuffer_ < outbufferend){
					*outbuffer_++ = 0;
				}
				*firstbp = 0;
			}

#ifndef FLOAT_BUG
      if(*scale1 == 1){          /*========= eq additional band ===========*/
      	inbuffer_ = (TWO *)inbufferstart;
      	outbuffer_ = (TWO *)outbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
				inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_++;

          out = a * out - b * *out1 - c * *out2;

          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
      }else{             /*======== eq first band ========*/
      	inbuffer_ = (TWO *)inbufferstart;
      	outbuffer_ = (TWO *)outbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          out = a * out - b * *out1 - c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
        inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;

          out = a * out - b * *out1 - c * *out2;

          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        *scale1 = 1;         /* reset scale1 if scale has been done */
      }
#else
      if(*scale1 == 1){           /* eq additional band */
      	inbuffer_ = (TWO *)inbufferstart;
      	outbuffer_ = (TWO *)outbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_++;
                           /* check to see if 0 to avoid slowing down */
                           /* on HP eqing 0 slowed it down sometimes */
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        
				inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          out = *inbuffer_++;

                           /* check to see if 0 to avoid slowing down */
                           /* on HP eqing 0 slowed it down sometimes */
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;

          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
      }else{                       /* eq first band */
      	inbuffer_ = (TWO *)inbufferstart;
      	outbuffer_ = (TWO *)outbufferstart;

				inbufferend -= 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;

          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;
          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }

        inbufferend += 4;
        while(inbuffer_ < inbufferend)
        {
          *inbuffer_ *= *scale1;            /* calculate main scale */
          out = *inbuffer_++;

                           /* check to see if 0 to avoid slowing down */
                           /* on HP eqing 0 slowed it down sometimes */
          if(out) out *= a;
          if(*out1) out -= b * *out1 + c * *out2;

          *outbuffer_++ += out;
          *out2 = *out1;
          *out1 = out;
        }
        *scale1 = 1;         /* reset scale1 if scale has been done */
      }
#endif
    }
  }
}
