#ifndef EQ_H
#define EQ_H

#include "defs.h"
#include "units.h"

typedef struct {
  int x, y, w, h;

  bcbutton in;
  bcbutton bp;
  bcpot levelpot, freqpot, widthpot;
} bceq;

extern int freqtable[TOTALFREQS + 1];    /* table of frequencies for frequency operations */

/* initialization functions */
int fromfreq(long value);
long tofreq(int value);
void loadfreq(FILE *in, int first);
void initfreq();
void savefreq(FILE *out);
void initeq(int track1, int newtracks);

/* interface functions */
void draweqcontrol(Drawable wdw, Window win, struct Eq *currenteq, int y);
void testeq(int x, int y, int track, struct Eq *currenteq);
void eqlevelmotion(XEvent *report);
void eqfreqmotion(XEvent *report);
void eqwidthmotion(XEvent *report);

/* file operations */
void writeeq(FILE *out);
void readeq(FILE *in, int track1);

/* playback functions */
void processeq(char *inbufferstart, long inbufferlength, struct Eq *currenteq,
  double *prevout, float *scale1);
void processbp(char *inbufferstart, long inbufferlength, char *outbufferstart, 
	struct Eq *currenteq, double *prevout, float *scale1, char *firstbp);

#endif
