#ifndef GRAPHICS_H
#define GRAPHICS_H

struct wavscroll_ {
  Window xwin, ywin;
  Pixmap xpixmap, ypixmap;
  int xscrollx, xscrolly, yscrollx, yscrolly; /* x and y positions of windows */
  bcscroll x, y;
} wavscroll;

struct wavdogear_ {
  Window win;
  Pixmap pixmap;
  int x, y, w, h;
  bcbox box;
} wavdogear;

void updatemaintitle(char *filename);
void allocatecolor(int red, int green, int blue, XColor *Col);
void allocatecolormap();
void loadfont();
void sizewindow();
void resizewindow(XEvent *report);
int initializescreen();
void refreshwav();
void refreshplay();
void refreshpatches();
void refresheq();
void refreshdisplay();
void refreshmenubar();
int drawcursor(int column1, int row1, int column2, int row2, long startx,
  long selectionstart, long selectionend);
int drawtime(long startx);
int drawlabels(long x);
void drawpatches(int starty);
void drawwavscrollbars();
int drawtitles(int column1, int row1, long column2, long row2, long startx,
  int starty);
int drawwave(int column1, int row1, long column2, long row2, long startx, int starty,
  char blank, char flash, char cursor);

#endif
