/* join sound file */
/* This program is (c) 1996 Adam Williams    swilliam@acs2.byu.edu      */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define REMOVE 1      /* remove source files if 1 */

#define COMPRESSOR "bzip2 -d "
#define verbose 1
#define BUFFER_SIZE4 10              /* # of segments */
#define BUFFER_SIZE6 1000000         /* # of bytes */

#define four int      /* long on macintosh, int on others */

#define two short int

#define MAGICNUMBER4 0x1234  /* 16 bit, 2 channel */
#define MAGICNUMBER6 0xfedc  /* 16 bit, 1 channel */

four filelength, buffersize;
four halfwaypt;
four time1, time2;
unsigned two SEGMENT_SIZE;
char infilename[256], outfilename[256], tempfilename[256];
char compressor[255];

FILE *in1, *in2, *in3, *in4, *out;

void getfilename(){
  char i=0;

  while((outfilename[i++] = fgetc(in1)) != 0)
    ;
}

four getfour(FILE *in){
  four number=0;

  number = (four)fgetc(in) << 24;
  number += (four)fgetc(in) << 16;
  number += (four)fgetc(in) << 8;
  number += fgetc(in);
  return number;
}

two gettwo(FILE *in){
  two number=0;

  number = (two)fgetc(in) << 8;
  number += fgetc(in);
  return number;
}

void join16(){
  four _buffersize;
  two _segmentsize;
  register two i;
  char *_buffer1, *_buffer2;
  char *bufferout, *buffer1, *buffer2, *buffer3, *buffer4;
  two j;

  if(!(in2=fopen(infilename, "rb"))){
    printf("Darn!  Couldn't open it!\n");
      remove(tempfilename);
    exit(0);
  }

  SEGMENT_SIZE = getfour(in1);

  halfwaypt = getfour(in1);
  fseek(in2, halfwaypt, SEEK_SET);

  buffersize = (four)BUFFER_SIZE4 * (four)SEGMENT_SIZE;

  if(!(buffer1 = malloc(buffersize))){
    printf("Not enough memory.\n");
      remove(tempfilename);
    exit(0);
  }

  if(!(buffer2 = malloc(buffersize))){
    printf("Not enough memory.\n");
      remove(tempfilename);
    exit(0);
  }

  if(!(bufferout = malloc(buffersize*2))){
    printf("Not enough memory.\n");
    remove(tempfilename);
    exit(0);
  }

  _segmentsize = SEGMENT_SIZE / 2;
  _buffersize = buffersize * 2;

  while(ftell(in2) < filelength-buffersize){
    fread(buffer1, buffersize, 1, in1);
    fread(buffer2, buffersize, 1, in2);

    _buffer1 = buffer1 + _segmentsize;
    _buffer2 = buffer2 + _segmentsize;

    for(j=0; j<BUFFER_SIZE4; j++){
      for(i = 0; i != _segmentsize; i++){
        *bufferout++ = *buffer1++;
        *bufferout++ = *buffer2++;
        *bufferout++ = _buffer1[i];
        *bufferout++ = _buffer2[i];
      }
      buffer1 += _segmentsize;
      _buffer1 = buffer1 + _segmentsize;
      buffer2 += _segmentsize;
      _buffer2 = buffer2 + _segmentsize;
    }
    bufferout -= _buffersize;
    buffer1 -= buffersize;
    buffer2 -= buffersize;

    if(!(fwrite(bufferout, _buffersize, 1, out))){
      printf("Disk error\n");
      remove(tempfilename);
      exit(0);
    }
    if(verbose){
      printf("%ld bytes joined\r", ftell(out));
      fflush(stdout);
    }
  }

  _buffersize = (four)SEGMENT_SIZE*2;
  while(ftell(in2) < filelength - SEGMENT_SIZE){
    fread(buffer1, SEGMENT_SIZE, 1, in1);
    fread(buffer2, SEGMENT_SIZE, 1, in2);

    _buffer1 = buffer1 + _segmentsize;
    _buffer2 = buffer2 + _segmentsize;

    for(i = 0; i != _segmentsize; i++){
      *bufferout++ = *buffer1++;
      *bufferout++ = *buffer2++;
      *bufferout++ = _buffer1[i];
      *bufferout++ = _buffer2[i];
    }

    bufferout -= _buffersize;
    buffer1 -= _segmentsize;
    buffer2 -= _segmentsize;

    if(!(fwrite(bufferout, _buffersize, 1, out))){
      printf("Disk error\n");
      remove(tempfilename);
      exit(0);
    }
  }
  if(verbose){
    printf("%ld bytes joined\r", ftell(out));
    fflush(stdout);
  }

  _buffersize = filelength-ftell(in2);
  _buffersize /= 2;
  _buffersize *= 2;
  _segmentsize = _buffersize / 2;
  fread(buffer1, _buffersize, 1, in1);
  fread(buffer2, _buffersize, 1, in2);

  _buffer1 = buffer1 + _segmentsize;
  _buffer2 = buffer2 + _segmentsize;

  for(i = 0; i < _segmentsize; i++){
    *bufferout++ = *buffer1++;
    *bufferout++ = *buffer2++;
    *bufferout++ = _buffer1[i];
    *bufferout++ = _buffer2[i];
  }
  bufferout -= _buffersize * 2;
  buffer1 -= _segmentsize;
  buffer2 -= _segmentsize;

  if(!(fwrite(bufferout, _buffersize * 2, 1, out))){
    printf("Disk error\n");
    remove(tempfilename);
    exit(0);
  }
  if(verbose){
    printf("%ld bytes joined\r", ftell(out));
    fflush(stdout);
  }

  fclose(in1);
  fclose(in2);
  fclose(out);
  free(buffer1);
  free(buffer2);
  free(bufferout);
}

void join16mon(){
  char *_buffer1, *_buffer2;
  char *bufferout, *buffer1, *buffer2;
  register four bufferoutpos, i;

  if(!(in2=fopen(infilename, "rb"))){
    printf("Darn!  Couldn't open it!\n");
      remove(tempfilename);
    exit(0);
  }

  SEGMENT_SIZE = getfour(in1);
  halfwaypt = getfour(in1);

  fseek(in2, halfwaypt, SEEK_SET);

  buffersize = BUFFER_SIZE6;

  if(!(buffer1 = malloc(buffersize))){
    printf("Not enough memory.\n");
      remove(tempfilename);
    exit(0);
  }

  if(!(buffer2 = malloc(buffersize))){
    printf("Not enough memory.\n");
      remove(tempfilename);
    exit(0);
  }

  if(!(bufferout = malloc(buffersize*2))){
    printf("Not enough memory.\n");
      remove(tempfilename);
    exit(0);
  }

  while(ftell(in2) < filelength){
    if(ftell(in2) > filelength - buffersize){
      buffersize = filelength - ftell(in2);
    }

    fread(buffer1, buffersize, 1, in1);
    fread(buffer2, buffersize, 1, in2);
    bufferoutpos = 0;

    for(i = 0; i != buffersize; i++){
        bufferout[bufferoutpos] = buffer1[i];
        bufferoutpos++;
        bufferout[bufferoutpos] = buffer2[i];
        bufferoutpos++;
    }

    if(!(fwrite(bufferout, buffersize*2, 1, out))){
      printf("Disk error\n");
      remove(tempfilename);
      exit(0);
    }
    if(verbose){
      printf("%ld bytes joined\r", ftell(out));
      fflush(stdout);
    }
  }

  fclose(in1);
  fclose(in2);
  fclose(out);
  free(buffer1);
  free(buffer2);
  free(bufferout);
}

void main(two argc, char *argv[]){
  two magicnumber;
  char response[10], i, *tokenptr;
  char _remove=0, len, _infilename[20][32], infilenames[256];

  if(verbose) printf("Sound joiner V. 8\n");

  if(argc >= 2){
    for(i = 1; i < argc; i++){
      strcpy(_infilename[i-1], argv[i]);
    }
    argc--;
  }else{
    printf("Enter the names of the files to process separated by spaces:\n");
    gets(infilenames);

    i=0;
    tokenptr = strtok(infilenames, " ");
    strcpy(_infilename[i++], tokenptr);

    while((tokenptr = strtok(NULL, " ")) != NULL && i <= 20){
      strcpy(_infilename[i++], tokenptr);
    }
    argc = i;
  }

  for(i=0; i<argc; i++){
    strcpy(infilename, _infilename[i]);

    if(!(in1=fopen(infilename, "rb"))){
      printf("\nCan't open %s.\n", infilename);
      exit(0);
    }

    time1 = time(0);

    if(fgetc(in1) == 0x42 && fgetc(in1) == 0x5a){
      fclose(in1);

      if(system(NULL)){
        if(verbose) printf("Decompressing\n");
        if(verbose) printf("%s --> ", infilename);
        strcpy(compressor, COMPRESSOR);
        strcat(compressor, infilename);
        if(system(compressor)){
          printf("\nRun %s to decompress %s and try again.\n", COMPRESSOR, infilename);
          exit(0);
        }
      }else{
        printf("\nRun %s to decompress %s and try again.\n", COMPRESSOR, infilename);
        exit(0);
      }
    }else
    	fclose(in1);
    	
    strtok(infilename, ".");
    sprintf(tempfilename, "%s.tmp", infilename);   
    if(verbose) printf("%s --> %s --> ", infilename, tempfilename);

    if(!(in1=fopen(infilename, "rb"))){
      printf("\nCan't open %s.\n", infilename);
      exit(0);
    }

    fseek(in1, 0, SEEK_END);
    filelength=ftell(in1);
    fseek(in1, 0, SEEK_SET);

    magicnumber = gettwo(in1);

    getfilename();
    if(verbose) printf("%s\n", outfilename);

    if(verbose) printf("%ld bytes to join.\n", filelength);

    if(!(strcmp(outfilename, infilename))){
      if(!REMOVE){
        printf("The original and new filenames are the same.  The original file\n");
        printf("will be replaced.  Do you really want to do this? [y/<n>]");
        gets(response);
        if(response[0] != 'y' && response[0] != 'Y') exit(0);
        else _remove = 1;
      }else _remove = 1;
    }else{
      if(out=fopen(outfilename, "rb")){
        printf("%s already exists.  Replace it? [y/n]", outfilename);
        gets(response);
        if(response[0] != 'y' && response[0] != 'Y') exit(0);
        else{
          fclose(out);
        }
      }
    }

    if(!(out=fopen(tempfilename, "wb"))){
      printf("Can't open temporary file.\n");
      exit(0);
    }

                  /* read magic numbers */
    switch(magicnumber & 0xffff){
      case MAGICNUMBER4:
        join16();
        break;

      case MAGICNUMBER6:
        join16mon();
        break;

      default:
        printf("Wrong magic number you MORmON!\n");
        exit(0);
        break;
    }
    time2 = time(0);

    if(verbose == 1) printf("\ntime: %ld:%ld\n", (time2-time1)/60, (time2-time1) - 60*((time2-time1)/60));

    remove(outfilename);
    if(rename(tempfilename, outfilename)) printf("Couldn't rename temp file\n");
    if(REMOVE && !_remove) remove(infilename);
  }
}
