#ifndef PICTURES_H
#define PICTURES_H

#include "defs.h"

typedef struct{
	int x, y;
	char *text;
} bctitle;


typedef struct {
  int x, y, w, h;
  char *text;
} bcbutton;

typedef struct {
  int x, y, w, h;
} bcbox;

void DrawTitle(Drawable wdw, Window win, bctitle *title);

void DrawRightArrow(Drawable wdw, int x, int y);
void DrawLeftEditCursor(Drawable wdw, int x, int y);
void DrawRightEditCursor(Drawable wdw, int x, int y);
void DrawLeftEdit(Drawable wdw, int x, int y);
void DrawRightEdit(Drawable wdw, int x, int y);

void DrawUpBox(Drawable wdw, int x1, int y1, int w, int h);
void DrawDnBox(Drawable wdw, int x1, int y1, int w, int h);
void DrawUpMenuBox(Drawable wdw, int x1, int y1, int w, int h);
void DrawDnMenuBox(Drawable wdw, int x1, int y1, int w, int h);

void DrawUpButton(Drawable wdw, Window win, bcbutton *button);
void DrawDnButton(Drawable wdw, Window win, bcbutton *button);
void DrawUpRadial(Drawable wdw, bcbutton *button);
void DrawDnRadial(Drawable wdw, bcbutton *button);

void DrawUpPlay(Drawable wdw, int x1, int y1, int width, int height);
void DrawDnPlay(Drawable wdw, int x1, int y1, int width, int height);
void DrawUpRec(Drawable wdw, int x1, int y1, int width, int height);
void DrawDnRec(Drawable wdw, int x1, int y1, int width, int height);
void DrawMeter(Drawable wdw, Window win, bcbox *box, long meterpeak);

void DrawUpRecord(Drawable wdw, Window win, bcbutton *button);
void DrawDnRecord(Drawable wdw, Window win, bcbutton *button);
void DrawUpPlayButton(Drawable wdw, Window win, bcbutton *button);
void DrawDnPlayButton(Drawable wdw, Window win, bcbutton *button);
void DrawUpStopButton(Drawable wdw, Window win, bcbutton *button);
void DrawDnStopButton(Drawable wdw, Window win, bcbutton *button);

void DrawUpDogEar(Drawable wdw, Window win, bcbox *box);
void DrawDnDogEar(Drawable wdw, Window win, bcbox *box);

void DrawEqSlider(Drawable wdw, Window win, int x, int y,
  int w, int h, int position, int value, char flash);

void DrawBpIcon(Drawable wdw, bcbutton *button);
void DrawEqIcon(Drawable wdw, bcbutton *button);

void DrawPatch(Drawable wdw, int x, int y1, struct Track
  *currenttrack, int track);

#endif
