/*
  Broadcast 2.0 multitrack audio editing
  (c) 1997 Adam Williams

  This program is distributed with the intent that it will be useful, without
  any warranty.  The code is being updated and has many bugs which are
  constantly being elucidated so changes should not be made without notifying
  the author.
*/

#include "playbox.h"
#include "bcast.h"
#include "timeconv.h"

struct PlayWindow playwindow = {
  200, 110, "Playback",
  {25, 5, 50, 50, ""},      /* record */
  {130, 5, 50, 50, ""},    /* playback */
  {79, 5, 50, 50, ""},      /* stop */
  {5, 60, 90, 20, ""},        /* selection start */
  {60, 85, 90, 20, ""},        /* selection length */
  {100, 60, 90, 20, ""}         /* selection end */
};

void drawplaycontrols(){
  XSetForeground(display, gc, grey.pixel);
  XFillRectangle(display, playpixmap, gc, 0, 0, playwindow.w, playwindow.h);
  DrawUpPlayButton(playpixmap, playwin, &playwindow.play);
  DrawUpRecord(playpixmap, playwin, &playwindow.record);
  DrawDnStopButton(playpixmap, playwin, &playwindow.stop);

  drawplayselection();

  XFlush(display);
}

void drawplayselection(){
  gettime(selectionstart, playwindow.start.text);

  gettime(selectionend, playwindow.end.text);

  gettime(selectionend - selectionstart, playwindow.length.text);

  create_text_box(playpixmap, playwin, &playwindow.start);
  create_text_box(playpixmap, playwin, &playwindow.end);
  create_text_box(playpixmap, playwin, &playwindow.length);
}
