#ifndef POT_H
#define POT_H

#include "defs.h"

#define POT_INT   0
#define POT_DB    1
#define POT_FREQ  2

typedef struct{
/* public */
	int x, y, w, h;         /* pot dimensions */
	
	/* for int:    value = float
	       db:     value = float db
	       freq:   value = reference int
	*/
	char type;  /* unit type */	
	float minvalue, maxvalue;  /* min and max values */
	float value;               /* value of pot data */

/* private */
	int x2, y2;                /* position of pointer relative to x, y */
	char text[32];             /* text representation of pot value */
} bcpot;

void initpot(Window win, Pixmap wdw, bcpot *box, int flash);
int potevent(Window win, Pixmap wdw, XEvent *report, bcpot *box, int flash);

#endif