#ifndef SCROLLBAR_H
#define SCROLLBAR_H

#include "defs.h"

#define ARROW1     1
#define ARROW2     2
#define SPAN       3
#define UPPAGE     4
#define DNPAGE     5

typedef struct {
  int x, y, w, h;
  long position;
  long span;
  long size;
  char event;             /* 0     ARROW1    ARROW2    SPAN */
} bcscroll;

void xscrollevent(Drawable wdw, Window win, XEvent *report, bcscroll *bar);
void yscrollevent(Drawable wdw, Window win, XEvent *report, bcscroll *bar);
void updatexscrollbar(Drawable wdw, Window win, long position, long span,
  long size, bcscroll *bar);
void updateyscrollbar(Drawable wdw, Window win, long position, long span,
  long size, bcscroll *bar);
void DrawXScrollBar(Drawable wdw, Window win, bcscroll *scrollbar);
void DrawYScrollBar(Drawable wdw, Window win, bcscroll *scrollbar);

#endif
