#ifndef SLIDER_H
#define SLIDER_H

#include "defs.h"

#define SLIDER_INT   0
#define SLIDER_DB    1
#define SLIDER_FREQ  2

typedef struct{
/* public */
	int x, y, w, h;         /* slider dimensions */
	
	/* for int:    value = float
	       db:     value = float db
	       freq:   value = reference int
	*/
	char type;  /* unit type */	
	float minvalue, maxvalue;  /* min and max values */
	float value;               /* value of slider data */

/* set by initslider */
	int position;           /* handle position in slider */
	char text[32];             /* text representation of slider value */
} bcslider;

/* store a textbox value as type in slider as value */
void texttoslider(bctextbox *box, bcslider *slider);
/* convert value of slider to textbox as type */
void slidertotext(bctextbox *box, bcslider *slider);

/* run this first to draw a slider, set position and text */
void initslider(Window win, Pixmap wdw, bcslider *box, int flash);

/* handle a slider event and set position and text again */
int sliderevent(Window win, Pixmap wdw, XEvent *report, bcslider *box, int flash);

#endif
