/* split 16 bit sound file version                                      */
/* This program is (c) 1996 Adam Williams    swilliam@acs2.byu.edu      */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define REMOVE 1

#define verbose 1
#define four long
#define two short int

#define BUFFER_SIZE4 10          /* segments */
#define SEGMENT_SIZE 27500

#define BUFFER_SIZE6 1000000     /* bytes */

#define MAGICNUMBER4 0x1234            /* 16 bit, 2 channel */
#define MAGICNUMBER6 0xfedc            /* 16 bit, 1 channel */
#define COMPRESSOR "bzip2 "

four buffersize, filelength, newsize, halfway;
char outfilename[64], infilename[64], tempfilename[64];
char *bufferin, *bufferout;
char compressor[255];
FILE *in;
FILE *out;

void createfilename(char *string){
  int i;
  srand(1);

  for(i = 0; i < 8; i++){
    string[i] = rand() % 10 + 48;
  }
  string[i] = '\0';
}

two isnum(char *string){
  static two len, i;

  len = strlen(string);
  for(i = 0; i < len; i++){
    if(isalpha(string[i])) return 0;
  }
  return 1;
}

void putfour(FILE *file, four number){
  fputc((number & 0xff000000) >> 24, file);
  fputc((number & 0xff0000) >> 16, file);
  fputc((number & 0xff00) >> 8, file);
  fputc(number & 0xff, file);
}

void split16a(){
  four _buffersize;
  register four bufferpos;
  two *_bufferin;
  register int i;
  int _segmentsize = SEGMENT_SIZE / 4;
  int j;
  char *_bufferout;

  while(ftell(in) < filelength-buffersize){
    fread(bufferin, buffersize, 1, in);

    for(j=0; j<BUFFER_SIZE4; j++){
      _bufferin = (two *)bufferin;
      _bufferout = bufferout + _segmentsize;

      for(i = 0; i != _segmentsize; i++){
        *bufferout++ = (*_bufferin++ & 0xff00) >> 8;
        _bufferout[i] = (*_bufferin++ & 0xff00) >> 8;
      }

      bufferin += SEGMENT_SIZE;
      bufferout += _segmentsize;
    }
    bufferout -= buffersize/2;
    bufferin -= buffersize;

    if(!(fwrite(bufferout, buffersize/2, 1, out))){
      printf("Disk error\n");
      exit(0);
    }

    if(verbose){
      printf("%ld bytes split\r", ftell(out));
      fflush(stdout);
    }
  }

  _buffersize = SEGMENT_SIZE/2;
  while(ftell(in) < filelength - SEGMENT_SIZE){
    fread(bufferin, SEGMENT_SIZE, 1, in);

    _bufferin = (two *)bufferin;
    _bufferout = bufferout + _segmentsize;

    for(i = 0; i != _segmentsize; i++){
      *bufferout++ = (*_bufferin++ & 0xff00) >> 8;
      _bufferout[i] = (*_bufferin++ & 0xff00) >> 8;
    }
    bufferout -= _segmentsize;

    if(!(fwrite(bufferout, _buffersize, 1, out))){
      printf("Disk error\n");
      exit(0);
    }
  }

  if(verbose){
    printf("%ld bytes split\r", ftell(out));
    fflush(stdout);
  }

  _buffersize=filelength-ftell(in);
  _segmentsize = _buffersize / 4;
  fread(bufferin, _buffersize, 1, in);

  _bufferin = (two *)bufferin;
  _bufferout = bufferout + _segmentsize;

  for(i = 0; i != _segmentsize; i++){
    *bufferout++ = (*_bufferin++ & 0xff00) >> 8;
    _bufferout[i] = (*_bufferin++ & 0xff00) >> 8;
  }

  bufferout -= _segmentsize;
  if(!(fwrite(bufferout, _buffersize/2, 1, out))){
    printf("Disk error\n");
    exit(0);
  }
  if(verbose){
    printf("%ld bytes split\r", ftell(out));
    fflush(stdout);
  }
}

void split16b(){
  four _buffersize;
  two *_bufferin;
  register int i;
  int _segmentsize = SEGMENT_SIZE / 4;
  int j;
  char *_bufferout;

  while(ftell(in) < filelength-buffersize){
    fread(bufferin, buffersize, 1, in);

    for(j=0; j<BUFFER_SIZE4; j++){
      _bufferin = (two *)bufferin;
      _bufferout = bufferout + _segmentsize;

      for(i = 0; i != _segmentsize; i++){
        *bufferout++ = *_bufferin++ & 0xff;
        _bufferout[i] = *_bufferin++ & 0xff;
      }

      bufferin += SEGMENT_SIZE;
      bufferout += _segmentsize;
    }
    bufferout -= buffersize/2;
    bufferin -= buffersize;

    if(!(fwrite(bufferout, buffersize/2, 1, out))){
      printf("Disk error\n");
      exit(0);
    }

    if(verbose){
      printf("%ld bytes split\r", ftell(out));
      fflush(stdout);
    }
  }

  _buffersize = SEGMENT_SIZE/2;
  while(ftell(in) < filelength - SEGMENT_SIZE){
    fread(bufferin, SEGMENT_SIZE, 1, in);

    _bufferin = (two *)bufferin;
    _bufferout = bufferout + _segmentsize;

    for(i = 0; i != _segmentsize; i++){
      *bufferout++ = *_bufferin++ & 0xff;
      _bufferout[i] = *_bufferin++ & 0xff;
    }
    bufferout -= _segmentsize;

    if(!(fwrite(bufferout, _buffersize, 1, out))){
      printf("Disk error\n");
      exit(0);
    }
  }

  if(verbose){
    printf("%ld bytes split\r", ftell(out));
    fflush(stdout);
  }

  _buffersize=filelength-ftell(in);
  _segmentsize = _buffersize / 4;
  fread(bufferin, _buffersize, 1, in);

  _bufferin = (two *)bufferin;
  _bufferout = bufferout + _segmentsize;

  for(i = 0; i != _segmentsize; i++){
    *bufferout++ = *_bufferin++ & 0xff;
    _bufferout[i] = *_bufferin++ & 0xff;
  }

  bufferout -= _segmentsize;
  if(!(fwrite(bufferout, _buffersize/2, 1, out))){
    printf("Disk error\n");
    exit(0);
  }
  if(verbose){
    printf("%ld bytes split\r", ftell(out));
    fflush(stdout);
  }
}

void split16mon(){
  register four bufferoutpos;
  two *_bufferin;
  register four i, j;

  _bufferin = (two *)bufferin;
  while(ftell(in) < filelength){
    if(ftell(in) > filelength - buffersize){
      buffersize = filelength - ftell(in);
    }

    fread(bufferin, buffersize, 1, in);
    bufferoutpos = 0;

    for(i = 0, j = 0; i < buffersize; i += 2, j++){
      bufferout[bufferoutpos++] = (_bufferin[j] & 0xff00) >> 8;
    }

    if(!(fwrite(bufferout, buffersize/2, 1, out))){
      printf("Disk error\n");
      exit(0);
    }

    if(verbose){
      printf("%ld bytes split\r", ftell(out));
      fflush(stdout);
    }
  }
}

void main(two argc, char *argv[]){
  four time1, time2, filepos;
  char response[10];
  char _remove=0;
  char *tokenptr, infilename[20][256], infilenames[256], i;
  two channels=0;
  four byteordertest;
  char byteorder;

  byteordertest = 0x00000001;
  byteorder = *((unsigned char *)&byteordertest);

  if(verbose){
    printf("16 bit sound splitter V. 7\n");
  }

  if(argc >= 2){
    for(i = 1; i < argc; i++){
    	if(isnum(argv[i])) channels = atol(argv[i]);
      else strcpy(infilename[i-1], argv[i]);
    }
    argc--;
  }else{
    printf("Enter the names of the files to process separated by spaces:\n");
    gets(infilenames);

    i=0;
    tokenptr = strtok(infilenames, " ");
    strcpy(infilename[i++], tokenptr);

    while((tokenptr = strtok(NULL, " ")) != NULL && i <= 20){
      strcpy(infilename[i++], tokenptr);
    }
    argc = i;
  }

  if(channels == 0){
    printf("Enter the number of channels in these files (1 or 2):\n");
    gets(response);
    channels = atol(response);
    if(channels < 1 | channels > 2){
      printf("Invalid # of channels\n");
      exit(0);
    }
  }else argc--;

  if(verbose){
  	if(channels == 2)
	    printf("16 bit stereo segment size= %d\n", SEGMENT_SIZE);
		else
			printf("16 bit mono segment size= %d\n", SEGMENT_SIZE);
  }

  for(i=0; i<argc; i++){
    strcpy(outfilename, infilename[i]);
    strtok(outfilename, ".");
    sprintf(tempfilename, "%s.tmp", infilename[i]);

    if(verbose) printf("%s --> %s --> %s\n", infilename[i],
      tempfilename, outfilename);

    if(!(strcmp(outfilename, infilename[i]))){
      if(!REMOVE){
        printf("The original and new filenames are the same.  The original file\n");
        printf("will be replaced.  Do you really want to do this? [y/n]");
        gets(response);
        if(response[0] != 'y' && response[0] != 'Y') exit(0);
        else _remove = 1;
      }else _remove = 1;
    }else{
      if(out=fopen(outfilename, "rb")){
        printf("%s already exists.  Replace it? [y/n]", outfilename);
        gets(response);
        if(response[0] != 'y' && response[0] != 'Y') exit(0);
        else{
          fclose(out);
        }
      }
    }

    if(!(in=fopen(infilename[i], "rb"))){
      printf("\nCan't open %s.\n", infilename[i]);
      exit(0);
    }
    if(!(out=fopen(tempfilename, "wb"))){
      printf("\nCan't open temp file.\n");
      exit(0);
    }

    if(channels == 2){
      fputc((MAGICNUMBER4 & 0xff00) >> 8, out);
      fputc(MAGICNUMBER4 & 0xff, out);
    }
    if(channels == 1){
      fputc((MAGICNUMBER6 & 0xff00) >> 8, out);
      fputc(MAGICNUMBER6 & 0xff, out);
    }

    fprintf(out, infilename[i]);
    fputc(0, out);

    putfour(out, SEGMENT_SIZE / 2);

    filepos = ftell(out);
    fputc(0, out);
    fputc(0, out);
    fputc(0, out);
    fputc(0, out);

    fseek(in, 0, SEEK_END);
    filelength=ftell(in);
    if(verbose) printf("%ld bytes to split.\n", filelength);

    fseek(in, 0, SEEK_SET);
    time1 = time(0);

    if(channels == 2){
      buffersize = (four)BUFFER_SIZE4 * (four)SEGMENT_SIZE;

      if(!(bufferin = malloc(buffersize))){
        printf("Not enough memory.\n");
        exit(0);
      }

      if(!(bufferout = malloc(buffersize))){
        printf("Not enough memory.\n");
        exit(0);
      }

      if(!byteorder) split16a();
      else split16b();
      halfway = ftell(out);
      fseek(out, filepos, SEEK_SET);
      putfour(out, halfway);
      fseek(out, halfway, SEEK_SET);
      fseek(in, 0, SEEK_SET);
      if(!byteorder) split16b();
      else split16a();
    }else

    if(channels == 1){
      buffersize = BUFFER_SIZE6;

      if(!(bufferin = malloc(buffersize))){
        printf("Not enough memory.\n");
        exit(0);
      }

      if(!(bufferout = malloc(buffersize))){
        printf("Not enough memory.\n");
        exit(0);
      }
      
			if(byteorder) fseek(in, 1, SEEK_SET);
			else fseek(in, 0, SEEK_SET);
      split16mon();
      halfway = ftell(out);
      fseek(out, filepos, SEEK_SET);
      putfour(out, halfway);
      fseek(out, halfway, SEEK_SET);
      if(byteorder) fseek(in, 0, SEEK_SET);
      else fseek(in, 1, SEEK_SET);
      buffersize = BUFFER_SIZE6;
      split16mon();
    }else
    
    {
    	printf("Channels out of range.\n");
    	exit(1);
    }

    free(bufferin);
    free(bufferout);
    fclose(in);
    fclose(out);
    if(REMOVE && !_remove) remove(infilename[i]);  /* remove the input file if it is named differently than the output file */
    if(_remove) remove(outfilename);
    rename(tempfilename, outfilename);

    if(system(NULL)){
      if(verbose) printf("\nCompressing\n");
      strcpy(compressor, COMPRESSOR);
      strcat(compressor, outfilename);
      if(system(compressor) && verbose) printf("Run bzip2 to compress %s\n", outfilename);

			sprintf(compressor, "%s%s", outfilename, ".bz2");
			if(in=fopen(compressor, "rb")){
				fseek(in, 0, SEEK_END);
				newsize = ftell(in);
				fclose(in);
			}
    }else{
      if(verbose) printf("Run bzip2 to compress %s\n", outfilename);
    }

    time2 = time(0);
    if(verbose) printf("\ntime: %ld:%ld  by %2.0f%%\n", 
    	(time2-time1)/60, (time2-time1) - 60*((time2-time1)/60),
    	100 - 100 * ((float)newsize / (float)filelength));
  }
}
