#include <math.h>

#include "defs.h"
#include "units.h"

                   /* conversion tables */
int freqtable[TOTALFREQS + 1];            /* table of frequency conversions */
float *topower;        /* topower[(int)(db * 10)] = (float)power */
                       /* range -45 to 20 db */


void initfreq(){         /* initialize frequency table */
  int i;
  double freq = 28;  /* starting frequency */
  long scale = 60;   /* some number divisable by three */

  freqtable[0] = 0;
  for(i = 1; i <= TOTALFREQS; i++){
    freqtable[i] = freq;
    freq = freq + freq / scale;
  }
}

long tofreq(int value){
  return(freqtable[value]);
}

/* return number of entry in freqtable which is lower or equal to value */
int fromfreq(long value){
  static int i;

  for(i = 0; i < TOTALFREQS && freqtable[i] < value; i++)
    ;
  return(i);
}

void initdb(){
	float i;
	
	/* db to power table */
	topower = malloc(sizeof(float) * (20 - INFINITYGAIN) * 10 + 1);
	topower += 200;
	for(i = INFINITYGAIN; i <= 20; i += 0.1){
		topower[(int)(i * 10)] = pow(2, i / 3);
	}
	topower[INFINITYGAIN * 10] = 0;   /* infinity gain */
}
